#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define x first
#define y second
#define pb push_back
#define mp make_pair

const int MOD = 998244353;

int pos[205], cop[205], len[205];
int dp[205][205][205], C[205][205];
int pref[205], pw[205][205];

int binpow(int x, int step)
{
    if (step == 0) return 1;
    if (step % 2 == 0)
    {
        int t = binpow(x, step / 2);
        return (ll) t * t % MOD;
    }
    else return (ll) x * binpow(x, step - 1) % MOD;
}

int rev(int x)
{
    return binpow(x, MOD - 2);
}

int CC(int n, int k)
{
    return C[n][k];
}

main() {
#ifdef HOME
    freopen("tt.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k, s;
    cin >> n >> k >> s;

    int need;
    for (int i = 1; i <= k; i++)
    {
        cin >> pos[i];
        if (pos[i] == s) need = i;
    }
    for (int i = 2; i <= k; i++) len[i] = pos[i] - pos[i - 1];
    len[1] = n + pos[1] - pos[k];
    //for (int i = 1; i <= k; i++) cout << len[i] << ' ';
    //cout << '\n';

    for (int i = 1; i <= k; i++) cop[i] = len[i <= need ? need - i + 1 : k - (i - need) + 1];
    for (int i = 1; i <= k; i++) len[i] = cop[i] % MOD;

    //for (int i = 1; i <= k; i++) cout << len[i] << ' ';
    //cout << '\n';

    C[0][0] = 1;
    for (int i = 1; i <= k; i++)
    {
        C[i][0] = C[i][i] = 1;
        for (int j = 1; j < i; j++) C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % MOD;
    }

    for (int i = 1; i <= k; i++)
        for (int j = 0; j <= k; j++)
            pw[i][j] = binpow(len[i], j);

    for (int start = 1; start <= k; start++)
    {
        dp[start][start - 1][0] = 1;
        dp[start][start][0] = 1;
        for (int i = start + 1; i <= k; i++)
            for (int ball = 0; ball <= i - start; ball++)
            {
                for (int last = ball - i + start + 1; last <= ball; last++)
                {
                    int p = pw[i][last];
                    dp[start][i][ball] = (dp[start][i][ball] + (ll) CC(ball, last) * p % MOD * dp[start][i - 1][ball - last] % MOD) % MOD;
                    //cout << "Partial: " << dp[i][ball] << ' ' << last << ' ' << ball << ' ' << i << '\n';
                }
                //cout << start << ' ' << i << ' ' << ball << ' ' << dp[start][i][ball] << '\n';
            }
    }
    dp[k + 1][k][0] = 1;
    dp[k + 1][k + 1][0] = 1;

    for (int i = 1; i <= k; i++) pref[i] = (pref[i - 1] + len[i]) % MOD;

    int obr = 1, ans = 0;
    int rv = rev(n);
    for (int i = 1; i <= k; i++)
    {
        obr = (ll) obr * rv % MOD;
        for (int j = 1; j <= i; j++)
        {
            int t = (ll) CC(i - 1, j - 1) * dp[1][j][j - 1] % MOD * dp[j + 1][k][i - j] % MOD * pref[j] % MOD;
            //cout << i << ' ' << j << ' ' << t << '\n';
            ans = (ans + (ll) t * obr % MOD * i % MOD) % MOD;
        }
    }
    cout << ans << '\n';
    return 0;
}

/*
3 1 2
2 1 3
2 0 0
3 0 0
3 1 0
3 0 0
1 1 2
2 1 0
2 2 0
3 1 0
3 2 0
3 3 0
332748118
*/


