#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define x first
#define y second
#define pb push_back
#define mp make_pair

int const maxn = 1005;
pair < pair < int, int >, pair < int, int > > a[maxn];

ll vecs(pair <ll, ll> A, pair <ll, ll> B)
{
    return A.x * B.y - A.y * B.x;
}

ll scal(pair <ll, ll> A, pair <ll, ll> B)
{
    return A.x * B.x + A.y * B.y;
}

int check(int ind, pair < int, int > cur) {
    pair <int, int> A = a[ind].x, B = a[ind].y;
    pair <int, int> C = cur;
    if (A == C || B == C) return 1;
    pair <int, int> K = mp(C.x - A.x, C.y - A.y), L = mp(C.x - B.x, C.y - B.y);
    if (vecs(K, L) == 0 && scal(K, L) < 0) return 1;
    else return 0;
}

int f(int ind, pair < ll, ll > cur) {
    ll A = a[ind].x.y - a[ind].y.y, B = a[ind].y.x - a[ind].x.x, C = (ll)a[ind].x.x * (ll)a[ind].y.y - (ll)a[ind].x.y * (ll)a[ind].y.x;
    ll val = A * cur.first + B * cur.second + C;
    if (val > 0) return 1;
    if (val == 0) return 0;
    return -1;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t, n;
    cin >> t;
    while (t--) {
        cin >> n;
        set < pair < int, int > > all_pt;
        for (int i = 1; i <= n; i++) {
            cin >> a[i].x.x >> a[i].x.y >> a[i].y.x >> a[i].y.y;
            all_pt.insert({a[i].x.x, a[i].x.y});
            all_pt.insert({a[i].y.x, a[i].y.y});
        }
        int answer = 0;
        for (auto key : all_pt) {
            vector < pair < int, int > > ind_k;
            vector < int > ind_m;
            for (int i = 1; i <= n; i++) {
                if (a[i].x == key) ind_k.push_back(a[i].y);
                else if (a[i].y == key) ind_k.push_back(a[i].x);
                else if (check(i, key)) ind_m.push_back(i);
            }
            for (int i = 0; i < (int)ind_k.size(); i++) {
                for (int j = i + 1; j < (int)ind_k.size(); j++) {
                    for (auto elem : ind_m) {
                        int v1 = f(elem, ind_k[i]), v2 = f(elem, ind_k[j]);
                        if (v1 == v2 && v1 != 0 && vecs({ind_k[i].x - key.x, ind_k[i].y - key.y}, {ind_k[j].x - key.x, ind_k[j].y - key.y}) != 0) {
                            answer++;
                        }
                    }
                }
            }
        }
        cout << answer << '\n';
    }
    return 0;
}

