#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll

signed main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    int T;
    cin >> T;
    while (T--) {
        int n, m;
        cin >> n >> m;
        vector<vector<char>> c(n, vector<char>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> c[i][j];
            }
        }
        int answer = 0;
        vector<int> pref_rows(m), suf_rows(m);
        vector<int> pref_best(n), suf_best(n);
        pair<int, int> mx = {0, 0};
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (int j = 0; j < m; j++) {
                if (c[i][j] == '#') {
                    if (cur > 0) {
                        if (cur > mx.first) {
                            mx.second = mx.first;
                            mx.first = cur;
                        } else if (cur > mx.second) {
                            mx.second = cur;
                        }
                    }
                    cur = 0;
                } else {
                    cur++;
                }
                pref_rows[j] = max(pref_rows[j], cur);
            }
            if (cur > 0) {
                if (cur > mx.first) {
                    mx.second = mx.first;
                    mx.first = cur;
                } else if (cur > mx.second) {
                    mx.second = cur;
                }
            }
            pref_best[i] = mx.first;
            answer = max(answer, mx.first + mx.second);
        }
        for (int j = 1; j < m; j++) {
            pref_rows[j] = max(pref_rows[j], pref_rows[j - 1]);
        }
        mx = {0, 0};
        for (int i = n - 1; i >= 0; i--) {
            int cur = 0;
            for (int j = m - 1; j >= 0; j--) {
                if (c[i][j] == '#') {
                    if (cur > 0) {
                        if (cur > mx.first) {
                            mx.second = mx.first;
                            mx.first = cur;
                        } else if (cur > mx.second) {
                            mx.second = cur;
                        }
                    }
                    cur = 0;
                } else {
                    cur++;
                }
                suf_rows[j] = max(suf_rows[j], cur);
            }
            if (cur > 0) {
                if (cur > mx.first) {
                    mx.second = mx.first;
                    mx.first = cur;
                } else if (cur > mx.second) {
                    mx.second = cur;
                }
            }
        }
        for (int j = m - 2; j >= 0; j--) {
            suf_rows[j] = max(suf_rows[j], suf_rows[j + 1]);
        }

        vector<vector<int>> dwn(n, vector<int>(m)), up(n, vector<int>(m));
        mx = {0, 0};
        for (int j = 0; j < m; j++) {
            int cur = 0;
            for (int i = 0; i < n; i++) {
                if (c[i][j] == '#') {
                    if (cur > 0) {
                        if (cur > mx.first) {
                            mx.second = mx.first;
                            mx.first = cur;
                        } else if (cur > mx.second) {
                            mx.second = cur;
                        }
                    }
                    cur = 0;
                } else {
                    cur++;
                }
            }
            if (cur > 0) {
                if (cur > mx.first) {
                    mx.second = mx.first;
                    mx.first = cur;
                } else if (cur > mx.second) {
                    mx.second = cur;
                }
            }
        }
        answer = max(answer, mx.first + mx.second);
        for (int j = 0; j < m; j++) {
            if (c[0][j] == '.') {
                up[0][j] = 1;
            } else {
                up[0][j] = 0;
            }
        }
        for (int i = 1; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (c[i][j] == '.') {
                    up[i][j] = up[i - 1][j] + 1;
                } else {
                    up[i][j] = 0;
                }
            }
        }

        //cout << "OK" << endl;
        for (int j = 0; j < m; j++) {
            if (c[n - 1][j] == '.') {
                dwn[n - 1][j] = 1;
            } else {
                dwn[n - 1][j] = 0;
            }
        }
        //cout << "OK" << endl;
        for (int i = n - 2; i >= 0; i--) {
            for (int j = 0; j < m; j++) {
                if (c[i][j] == '.') {
                    dwn[i][j] = dwn[i + 1][j] + 1;
                } else {
                    dwn[i][j] = 0;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (c[i][j] == '#') {
                    continue;
                }

                int ad = 0;
                if (j > 0) {
                    ad = max(ad, pref_rows[j - 1]);
                }
                if (j + 1 < m) {
                    ad = max(ad, suf_rows[j + 1]);
                }

                int ad2 = ad, ad3 = ad;
                if (i > 0) {
                    ad2 = max(ad2, pref_best[i - 1]);
                }
                if (i + 1 < n) {
                    ad3 = max(ad3, suf_best[i + 1]);
                }

                if (i + dwn[i][j] < n) {
                    ad2 = max(ad2, suf_best[i + dwn[i][j]]);
                }
                if (i - up[i][j] > 0) {
                    ad3 = max(ad3, pref_best[i - up[i][j]]);
                }
                answer = max(answer, dwn[i][j] + ad2);
                answer = max(answer, up[i][j] + ad3);
            }
        }
        cout << answer << '\n';
    }
}
