#include <bits/stdc++.h>

#define int ll
#define pb push_bak
#define ft first
#define sc second
#define len(v) int(v.size())

typedef long long ll;

using namespace std;


const int N = (1 << 18);
const int inf = 1e9 + 100;

vector<int> tree(2 * N, 0);

int get_one(int x) {
    return tree[N + x];
}

int get_min(int v, int vl, int vr, int l, int r) {
    if (r <= vl || vr <= l) {
        return inf;
    }
    if (l <= vl && vr <= r) {
//        cout << v << " " << vl << " " << vr << " " << N + 0 << endl;
        return tree[v];
    }
    int m = (vl + vr) / 2;
    return min(get_min(v * 2, vl, m, l, r), get_min(v * 2 + 1, m, vr, l, r));
}

void upd_min(int x, int val) {
    tree[N + x] += val;
    int cur = (N + x) / 2;
    while (cur > 0) {
        tree[cur] = min(tree[cur * 2], tree[cur * 2 + 1]);
        cur /= 2;
    }
}

int get_min(int l, int r) {
    return get_min(1, 0, N, l, r);
}

int get_i(int i) {
    int l = -1, r = N;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (get_min(0, m + 1) >= i) {
            l = m;
        } else {
            r = m;
        }
    }
//    cout << l << " " << get_min(0, 1) << " " << tree[N + 0] << endl;
    return l + 1;
}

int recalc_ans(int ans, int p, int v) {
    int i = get_one(v);
    if (p == 1) {
        i += 1;
        ans -= get_i(i);
        upd_min(v, 1);
        ans += get_i(i);
    } else {
        ans -= get_i(i);
        upd_min(v, -1);
        ans += get_i(i);
    }
    return ans;
}

int calc_ans(vector<int>& kek) {
    int cur_min = inf;
    int ans = 0;
    for (int i = 0; i < len(kek); i++) {
        cur_min = min(cur_min, kek[i]);
        ans -= cur_min * i;
        ans += cur_min * (i + 1);
    }
    return ans;
}

void build_tree(vector<int>& kek) {
    for (int i = 0; i < len(kek); i++) {
        upd_min(i, kek[i]);
    }
}

signed main() {
#ifdef PC
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<int> kek(n);
    for (int i = 0; i < n; i++) {
        cin >> kek[i];
    }
    build_tree(kek);
    auto ans = calc_ans(kek);

    int q;
    cin >> q;
    cout << ans << '\n';
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        ans = recalc_ans(ans, p, v);
        cout << ans << '\n';
    }

    return 0;
}
