#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, q;
	cin >> n >> q;

	map<pair<int, int>, int> p;

	auto compute = [&](auto&& self, int x, int y) -> int {
		if (x == 1 && y == 1) {
			return -1;
		}
		if (p.count(make_pair(x, y))) {
			return p[make_pair(x, y)];
		}
		return p[make_pair(x, y)] = (y == 0 ? x : self(self, y, x / y));
	};

	vector<pair<int, int>> ans;
	ans.reserve(int(5e6));
	for (int x = 1; x <= n; ++x) {
		for (int y = 0; y <= n && y * x <= n; ++y) {
			int g = compute(compute, x, y);
			if (g > 0 && x % g == 0) {
				for (int z = y == 0 ? x : x * y; z <= n && z < x * (y + 1); z += g) {
					if (gcd(x, z) == g) {
						ans.emplace_back(z, x);
					}
				}
			}
		}
	}
	sort(ans.begin(), ans.end());

	while (q--) {
		ll t; cin >> t; --t;
		if (t >= int(ans.size())) {
			cout << -1 << ' ' << -1 << '\n';
		} else {
			cout << ans[t].first << ' ' << ans[t].second << '\n';
		}
	}
}
