#include<bits/stdc++.h>

using namespace std;

int n, m;
bool **a;
int **pref, **suff;
int **lef, **rig, **up, **down;

void init() {
    a = new bool*[n + 2];
    pref = new int*[n + 2];
    suff = new int*[n + 2];
    lef = new int*[n + 2];
    rig = new int*[n + 2];
    up = new int*[n + 2];
    down = new int*[n + 2];
    for (int i = 0; i <= n + 1; ++i) {
        a[i] = new bool[m + 2];
        pref[i] = new int[m + 2];
        suff[i] = new int[m + 2];
        lef[i] = new int[m + 2];
        rig[i] = new int[m + 2];
        up[i] = new int[m + 2];
        down[i] = new int[m + 2];
        fill(a[i], a[i] + m + 2, false);
        fill(pref[i], pref[i] + m + 2, 0);
        fill(suff[i], suff[i] + m + 2, 0);
        fill(lef[i], lef[i] + m + 2, 0);
        fill(rig[i], rig[i] + m + 2, 0);
        fill(up[i], up[i] + m + 2, 0);
        fill(down[i], down[i] + m + 2, 0);
    }
}

void solve() {
    cin >> n >> m;
    init();
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            if (s[j - 1] == '#') a[i][j] = false;
            else a[i][j] = true;
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            up[i][j] = a[i][j] ? up[i - 1][j] + 1 : 0;
            lef[i][j] = a[i][j] ? lef[i][j - 1] + 1 : 0;
            pref[i][j] = max(max(pref[i - 1][j], pref[i][j - 1]), max(up[i][j], lef[i][j]));
        }
    }
    for (int i = n; i >= 1; --i) {
        for (int j = m; j >= 1; --j) {
            down[i][j] = a[i][j] ? down[i + 1][j] + 1 : 0;
            rig[i][j] = a[i][j] ? rig[i][j + 1] + 1 : 0;
            suff[i][j] = max(max(suff[i + 1][j], suff[i][j + 1]), max(down[i][j], rig[i][j]));
        }
    }
    int ans = 0;
    for (int x = 1; x <= n; ++x) {
        for (int y = 1; y <= m; ++y) {
            int A = pref[x][y];
            int B = max(suff[x + 1][1], suff[1][y + 1]);
            ans = max(ans, A + B);
        }
    }
    cout << ans << "\n";
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
