#include <bits/stdc++.h>

using namespace std;

bool dp[101][101];
pair<int, int> par[101][101];
bool parf[101][101];

void solve(int a, int b, int par_a, int par_b, bool flag) {
    int g = gcd(a, b);
    a /= g;
    b /= g;
    if (a > 100 or b > 100) return;
    if (a + b > 10000 or dp[a][b]) return;
    dp[a][b] = true;
    if (a > 1 or b > 1) {
        par[a][b] = make_pair(par_a, par_b);
        parf[a][b] = flag;
    }
    solve(a, a + b, a, b, true), solve(b, a + b, a, b, false);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve(1, 1, 0, 0, false);
    int a, b;
    cin >> a >> b;
    a *= a;
    b *= b;
    int g = gcd(a, b);
    a /= g;
    b /= g;
    vector<string> ans;
    bool big = (a > b);
    if (big) {
        swap(a, b);
    }
    int x = a, y = b;
    while (x > 0 or y > 0) {
        if (parf[x][y]) {
            ans.push_back("sin");
        } else {
            ans.push_back("cos");
        }
        ans.push_back("atan");
        int nx = par[x][y].first;
        int ny = par[x][y].second;
        x = nx, y = ny;
    }
    reverse(ans.begin(), ans.end());
    if (big) {
        ans.push_back("atan");
        ans.push_back("sin");
        ans.push_back("acos");
        ans.push_back("tan");
    }
    for (auto kek : ans) cout << kek << ' ';

    return 0;
}