#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const int INF = INT_MAX;

void solve();

int main() {
    input();
    solve();
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    multiset<ll> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ans = 0;
    sort(a.begin(), a.end());
    for (int i = 0; i < k; i++) {
        s.insert(a[i]);
        ans += a[i];
    }
    for (int i = k ; i < n; i++) {
        auto it = s.begin();
        ll next = * it + a[i];
        ans += next;
        s.erase(it);
        s.insert(next);
    }
    cout << ans;
}

