#include<bits/stdc++.h>
using namespace std;

// #define LOCAL
// #define MULTITEST

#define int long long

#ifdef LOCAL 
	#define debug(x) cerr << #x << " = " << x << endl;
	#define ddebug(x, y) cerr << #x << " = " << x << " , " << #y << " = " << y << endl;
#else
	#define debug(x);
	#define ddebug(x, y);
#endif

#define ll long long
#define ld long double

#define pii pair<int, int>
#define fi first
#define se second

#define vi vector<int> 
#define vvi vector<vi>
#define pb push_back

#define vpii vector<pii>
#define vvpii vector<vpii>

#define ALL(x) x.begin(), x.end()

const int INF32 = 2e9 + 5;
const ll INF64 = 4e9 + 5;	

const int mod = 1e9 + 7;
const ld eps = 1e-10;

const int sz = 20;
const int SZ = 1 << 20;

void Solve(){

	int n, k;
	cin >> n >> k;
	vi d(n);
	for (int i = 0; i < n; i++){
		cin >> d[i];
	}

	sort(ALL(d));
	reverse(ALL(d));

	multiset<int> s;
	for (int i = 0; i < k; i++){
		s.insert(0);
	}

	int ans = 0;
	while (d.size()){
		auto it = s.begin();
		int cur = (*it) + d.back();
		s.erase(it);
		d.pop_back();
		s.insert(cur);
		ans += cur;
	}

	cout << ans;

}

signed main(){

	srand(time(NULL));
	cout << fixed << setprecision(10);

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		// freopen("output.txt", "w", stdout);
	#else
		ios_base::sync_with_stdio(NULL);
		cin.tie(NULL);
		cout.tie(NULL);
	#endif

	int test_cnt = 1;
	#ifdef MULTITEST
		cin >> test_cnt;
	#endif
	
	for(int i = 1; i <= test_cnt; i++){
		Solve();
		cout << '\n';
	}
}