#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

int get(int n, int m, vector<string> &v) {
    int res = -1;
    for (int j = 0; j < m; j++) {
        int cur = 0;
        for (int i = 0; i < n; i++) {
            if (v[i][j] == '.') cur++;
            else cur = 0;
            res = max(res, cur);
        }
    }
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') cur++;
            else cur = 0;
            res = max(res, cur);
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {

        int n, m;
        cin >> n >> m;
        vector<string> v(n);
        for (int i = 0; i < n; i++) {
            cin >> v[i];
        }
        int col_id = -1, max_col = -1, row_beg = -1;
        for (int j = 0; j < m; j++) {
            int cur = 0, cur_beg = 0;
            for (int i = 0; i < n; i++) {
                if (v[i][j] == '.') {
                    if (cur == 0) cur_beg = i;
                    cur++;
                } else {
                    cur = 0;
                }
                if (cur > max_col) {
                    row_beg = cur_beg;
                    max_col = cur;
                    col_id = j;
                }
            }
        }

        int ans1 = 0, ans2 = 0;
        for (int i = row_beg, kk = 0; i < n && kk < max_col; i++, kk++) {
            ans1++;
            v[i][col_id] = '#';
        }

//        for (auto it : v) {
//            cout << it << '\n';
//        }
//        cout << '\n';
        ans1 += get(n, m, v);
        for (int i = row_beg; i < row_beg + max_col; i++) {
            v[i][col_id] = '.';
        }
//        for (auto it : v) {
//            cout << it << '\n';
//        }
//        cout << '\n';

        int row_id = -1, max_row = -1, col_beg = -1;
        for (int i = 0; i < n; i++) {
            int cur = 0, cur_beg = 0;
            for (int j = 0; j < m; j++) {
                if (v[i][j] == '.') {
                    if (cur == 0) cur_beg = j;
                    cur++;
                } else {
                    cur = 0;
                }
//                cout << i << ' ' << cur << ' ' << max_row << '\n';
                if (cur > max_row) {
                    col_beg = cur_beg;
                    max_row = cur;
                    row_id = i;
                }
            }
        }
//        cout << row_id << ' ' << max_row << ' ' << col_beg << '\n';

        for (int j = col_beg; j < col_beg + max_row; j++) {
//            cout << j << '\n';
            ans2++;
            v[row_id][j] = '#';
        }
//        for (auto it : v) {
//            cout << it << '\n';
//        }
//        cout << '\n';
        ans2 += get(n, m, v);
        cout << max(ans1, ans2) << '\n';
    }
}

