#include <bits/stdc++.h>

using namespace std;

enum F {
    SIN = 0,
    COS = 1,
    TAN = 2,
    ATAN = 3,
    ASIN = 4,
    ACOS = 5
};


vector<F> ans;

vector<pair<vector<F>, double>> possibilies;
vector<F> current_seq;
void get_all_possible_ways(double x, int current_depth) {
    if (current_depth == 4) {
        return;
    }
    if (current_depth != 0) {
        possibilies.emplace_back(current_seq, x);
    }
    current_seq.push_back(SIN);
    get_all_possible_ways(sin(x), current_depth + 1);
    current_seq.pop_back();

    current_seq.push_back(COS);
    get_all_possible_ways(cos(x), current_depth + 1);
    current_seq.pop_back();

    current_seq.push_back(TAN);
    get_all_possible_ways(tan(x), current_depth + 1);
    current_seq.pop_back();

    current_seq.push_back(ASIN);
    get_all_possible_ways(asin(x), current_depth + 1);
    current_seq.pop_back();

    current_seq.push_back(ACOS);
    get_all_possible_ways(acos(x), current_depth + 1);
    current_seq.pop_back();

    current_seq.push_back(ATAN);
    get_all_possible_ways(atan(x), current_depth + 1);
    current_seq.pop_back();
}


double get_num(double x, double y) {
    while (abs(x - y) > 1e-9 && ans.size() <= 990) {
        possibilies.clear();
        get_all_possible_ways(x, 0);
        double cur_eps = 11;
        vector<F> tmp;
        double new_ans;
        for (auto [ops, kk] : possibilies) {
            if (abs(y - kk) < cur_eps) {
                cur_eps = abs(y - kk);
                tmp = ops;
                new_ans = kk;
            }
        }
        ans.insert(ans.end(), tmp.begin(), tmp.end());
        x = new_ans;
    }
    return x;
}

void solve() {
    int a, b;
    cin >> a >> b;
    bool reversed = false;
    double y = double(a) / double(b);
    int lol = 0;
    if (a > b) {
        lol++;
        reversed = true;
        y = atan(1/y);
    }
    auto kek = get_num(0, y);
    lol += ans.size();
    cout << lol << endl;
    if (reversed) {
        cout << "tan ";
    }
    std::reverse(ans.begin(), ans.end());
    for (auto i : ans) {
        switch (i) {
            case SIN:
                cout << "sin ";
                break;
            case COS:
                cout << "cos ";
                break;
            case TAN:
                cout << "tan ";
                break;
            case ASIN:
                cout << "asin ";
                break;
            case ACOS:
                cout << "acos ";
                break;
            case ATAN:
                cout << "atan ";
                break;
        }
    }
}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r", stdin);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
