#include <bits/stdc++.h>

#define S second
#define F first
#define sz(x) int(x.size())

using namespace std;

int main()
{
    int t;

    cin >> t;

    for (; t; t--) {
        int n, m;

        cin >> n >> m;

        string s[n];

        for (int i = 0; i < n; i++)
            cin >> s[i];

        multiset <int> se; se.clear();

        int cl[n][m][2], rw[n][m][2];

        for (int j = 0; j < m; j++)
            for (int i = n - 1; i >= 0; i--)
            {
                cl[i][j][0] = 0;

                if (s[i][j] == '.') {
                    cl[i][j][0]++;

                    if (i + 1 != n)
                        cl[i][j][0] += cl[i + 1][j][0];
                }
            }

        for (int j = 0; j < m; j++)
            for (int i = 0; i < n; i++)
            {
                cl[i][j][1] = 0;

                if (s[i][j] == '.') {
                    cl[i][j][1]++;

                    if (i != 0)
                        cl[i][j][1] += cl[i - 1][j][1];
                }
            }

        for (int j = m - 1; j >= 0; j--)
            for (int i = 0; i < n; i++)
            {
                rw[i][j][0] = 0;

                if (s[i][j] == '.') {
                    rw[i][j][0]++;

                    if (j + 1 != m)
                        rw[i][j][0] += rw[i][j + 1][0];
                }
            }

        for (int j = 0; j < m; j++)
            for (int i = 0; i < n; i++)
            {
                rw[i][j][1] = 0;

                if (s[i][j] == '.') {
                    rw[i][j][1]++;

                    if (j != 0)
                        rw[i][j][1] += rw[i][j - 1][1];
                }
            }

        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
            {
                if (s[i][j] == '.') {
                    se.insert(rw[i][j][0]);

                    while (j < m && s[i][j] == '.')
                        j++;
                }
            }

        for (int j = 0; j < m; j++)
            for (int i = 0; i < n; i++)
            {
                if (s[i][j] == '.') {
                    se.insert(cl[i][j][0]);

                    while (i < n && s[i][j] == '.')
                        i++;
                }
            }

        int ans = 0;

        for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            if (s[i][j] == '#')
                continue;

            int ws = rw[i][j][0];

            se.erase(se.find(ws));

            int mx = ws;

            int fr = j;

            while (j < m && s[i][j] == '.') {
                int ps = i - cl[i][j][1] + 1;

                se.erase(se.find(cl[ps][j][0]));

                mx = max(mx, ws + max(cl[i][j][0] - 1, cl[i][j][1] - 1));

                j++;
            }

            if (sz(se)) {
                mx = max(mx, ws + *se.rbegin());
            }

            se.insert(ws);

            while (fr < m && s[i][fr] == '.') {
                int ps = i - cl[i][fr][1] + 1;

                se.insert(cl[ps][fr][0]);

                fr++;
            }

            ans = max(ans, mx);
        }

        for (int j = 0; j < m; j++)
        for (int i = 0; i < n; i++)
        {
            if (s[i][j] == '#')
                continue;

            int ws = cl[i][j][0];

            se.erase(se.find(ws));

            int mx = ws;

            int fr = i;

            while (i < n && s[i][j] == '.') {
                int ps = j - rw[i][j][1] + 1;

                se.erase(se.find(rw[i][ps][0]));

                mx = max(mx, ws + max(rw[i][j][0] - 1, rw[i][j][1] - 1));
                i++;
            }

            if (sz(se)) {
                mx = max(mx, *se.rbegin() + ws);
            }

            se.insert(ws);

            while (fr < n && s[fr][j] == '.') {
                int ps = j - rw[fr][j][1] + 1;

                se.insert(rw[fr ][ps][0]);

                fr++;
            }

            ans = max(ans, mx);
        }

        cout << ans << endl;
    }
}
