#include <bits/stdc++.h>

using namespace std;

int main() {
#define int long long
    int n, m, t;
    cin >> t;

    struct brick {
        int i, j, length;
        vector<brick *> intersects;

        brick(int i, int j, int length) : i(i), j(j), length(length), intersects() {};
    };

    for (; t > 0; t--) {
        cin >> n >> m;
        vector<brick *> hor;
        vector<brick *> ver;
        vector<vector<bool>> used = vector<vector<bool>>(n, vector<bool>(m, false));
        vector<vector<brick *>> p = vector<vector<brick *>>(n, vector<brick *>(m, nullptr));
        string s;
        getline(cin, s);
        for (int i = 0; i < n; i++) {
            getline(cin, s);
            for (int j = 0; j < m; j++) {
                if (s[j] == '.') {
                    used[i][j] = true;
                    if (j > 0 && p[i][j - 1]) {
                        p[i][j] = p[i][j - 1];
                        p[i][j]->length++;
                    } else {
                        hor.push_back(new brick(i, j, 1));
                        p[i][j] = hor.back();
                    }
                }
            }
        }

        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n; i++) {
                if (used[i][j]) {
                    if (i > 0 && p[i - 1][j]) {
                        if (p[i][j]->length > 1) {
                            p[i - 1][j]->intersects.push_back(p[i][j]);
                        }
                        p[i][j] = p[i - 1][j];
                        p[i][j]->length++;
                    } else {
                        ver.push_back(new brick (i, j, 1));
                        if (p[i][j]->length > 1) {
                            ver.back()->intersects.push_back(p[i][j]);
                        }
                        p[i][j] = ver.back();
                    }
                }
            }
        }

        int m = 0;

        sort(hor.begin(), hor.end(), [](const auto &l, const auto &r) { return l->length > r->length; });
        sort(ver.begin(), ver.end(), [](const auto &l, const auto &r) { return l->length > r->length; });

        if (hor.size() == 1) {
            m = max(hor[0]->length, m);
        }

        if (ver.size() == 1) {
            m = max(ver[0]->length, m);
        }

        if (hor.size() > 1) {
            m = max(hor[0]->length + hor[1]->length, m);
        }

        if (ver.size() > 1) {
            m = max(ver[0]->length + ver[1]->length, m);
        }

        for
        (const auto & v : ver) {


            for (const auto & j : v->intersects) {
                const auto & h = *j;
                auto d1 = abs(h.j - v->j);
                auto d2 = h.length - d1 - 1;
                m = max(m, v->length + max(d1, d2));

                d1 = abs(h.i - v->i);
                d2 = v->length - d1 - 1;
                m = max(m, h.length + max(d1, d2));
            }

            for (const auto & h: hor) {
                if (!(v->i + v->length > h->i && h->j + h->length > v->j)) {
                    m = max (m, v->length + h->length);
                    break;
                }
            }

        }


        std::cout << m << endl;
    }
    return 0;
}
