#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    int h1, m1, h2, m2;
    char c;
    cin >> h1 >> c >> m1 >> h2 >> c >>  m2;
    vector<vector<int>> dist(24, vector<int>(60, -1));
    queue<pair<int, int>> q;
    dist[h1][m1] = 0;
    q.push({h1, m1});
    while (!q.empty()) {
        auto cur = q.front();
        q.pop();
        //f1
        {
            int m = cur.second + 1;
            int h = cur.first + m / 60;
            m %= 60;
            h %= 24;
            if (dist[h][m] == -1) {
                dist[h][m] = dist[cur.first][cur.second] + 1;
                q.push({h, m});
            }
        }
        //f2
        {
            int m = cur.second;
            int h = cur.first + 1;
            h %= 24;
            if (dist[h][m] == -1) {
                dist[h][m] = dist[cur.first][cur.second] + 1;
                q.push({h, m});
            }
        }
    }
    cout << dist[h2][m2] << '\n';
}