/*
 * Copyright © 6highloads (Shik, Kirsanov, Ushkov)
 * 2022
 */


#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

using namespace std;

using ll = int64_t;

int getTime(string &s) {
    int res = 0;
    for (char c : s) {
        res *= 10;
        res += (c - '0');
    }
    return res;
}

pair<int, int> getHM(string& s) {
    int del = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == ':') {
            del = i;
            break;
        }
    }
    string h = s.substr(0, del);
    string m = s.substr(del + 1);
    return {getTime(h), getTime(m)};
}

int main() {
    fastio;

    string s, t;
    cin >> s >> t;

    auto ss = getHM(s);
    int sh = ss.first;
    int sm = ss.second;

    auto tt = getHM(t);
    int th = tt.first;
    int tm = tt.second;

    if (sh == th && sm == tm) {
        cout << 0;
        return 0;
    }

    int ops = 0;
    if (sm <= tm) {
        ops += tm - sm;
    } else {
        sh++;
        ops += 60 - sm;
        ops += tm;
    }

    if (sh <= th) {
        ops += th - sh;
    } else {
        ops += 24 - sh;
        ops += th;
    }

    cout << ops;
    return 0;
}
