#include <iostream>
#include <vector>
#include <map>
#include <numeric>
#include <algorithm>
using namespace ::std;
#define ll long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pairInt pair<int, int>
#define pairLL pair<ll, ll>

int n, m;
vector<string> vect;

int findMaxM(const vector<string> &vect)
{
	int maxL1 = 0;
	int curentLenght = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (vect[i][j] == '#')
			{
				if (curentLenght > maxL1)
				{
					maxL1 = curentLenght;
				}
				curentLenght = 0;
			}
			else
			{
				curentLenght++;
			}
		}
	}
	return maxL1;
}


int findMaxN(const vector<string>& vect)
{
	int maxL1 = 0;
	int curentLenght = 0;
	for (int j = 0; j < m; j++)
	{
		for (int i = 0; i < n; i++)
		{
			if (vect[i][j] == '#')
			{
				if (curentLenght > maxL1)
				{
					maxL1 = curentLenght;
				}
				curentLenght = 0;
			}
			else
			{
				curentLenght++;
			}
		}
	}
	return maxL1;
}

vector<string> rebuildN(vector<string> vect, int myMax)
{
	int curentLenght = 0;
	for (int j = 0; j < m; j++)
	{
		for (int i = 0; i < n; i++)
		{
			if (vect[i][j] == '#')
			{
				if (curentLenght == myMax)
				{
					i--;
					while (vect[i][j] != '#')
					{
						vect[i][j] = '#';
						i--;
					}
					return vect;
				}
				curentLenght = 0;
			}
			else
			{
				curentLenght++;
			}
		}
	}
}

vector<string> rebuildM(vector<string> vect, int myMax)
{
	int curentLenght = 0;
	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < m; i++)
		{
			if (vect[j][i] == '#')
			{
				if (curentLenght == myMax)
				{
					i--;
					while (vect[j][i] != '#')
					{
						vect[j][i] = '#';
						i--;
					}
					return vect;
				}
				curentLenght = 0;
			}
			else
			{
				curentLenght++;
			}
		}
	}
}

void doWork()
{
	cin >> n >> m;
	n += 2;
	m += 2;
	vect = vector<string>(n);
	{
		string tmp = "";
		for (int i = 0; i < m; i++)
		{
			tmp += '#';
		}
		vect[0] = tmp;
		vect[n - 1] = tmp;
	}
	for (int i = 0; i < n - 2; i++)
	{
		cin >> vect[i+1];
		vect[i+1] = '#' + vect[i+1] + '#';
	}


	int ans = 0;

	int maxN = findMaxN(vect);
	int maxM = findMaxM(vect);

	vector<string> vectN = rebuildN(vect, maxN);
	vector<string> vectM = rebuildM(vect, maxM);

	ans = maxN + findMaxN(vectN);
	ans = max(maxN + findMaxM(vectN), ans);
	ans = max(maxM + findMaxN(vectM), ans);
	ans = max(maxM + findMaxM(vectM), ans);

	cout << ans << "\n";


	

}

int main()
{
	int t = 1;
	cin >> t;
	while (t--)
	{
		doWork();
	}
	return 0;
}