import java.io.BufferedReader
import java.io.BufferedWriter
import java.io.StreamTokenizer

fun main() = withFastOut(readInt()) {
    val (n, m) = readInts()
    val d = Array(n) { read().map { it == '.' } }
    data class Interval(var s: Int, val start: Int, var end: Int)
    val s = Array(m) { listOf<Interval>() }
    for (j in 0 until m) {
        val res = mutableListOf<Interval>()
        var cur = Interval(0, 0, 0)
        for (i in 0 until n) {
            if (d[i][j]) {
                cur.s++
                cur.end++
            } else {
                if (cur.s > 0 || res.isEmpty()) res += cur
                cur = Interval(0, i + 1, i + 1)
            }
        }
        if (res.lastOrNull() != cur) res += cur
        s[j] = res.sortedByDescending { it.s }.take(2)
    }
    val lines = mutableListOf<List<Interval>>()
    var ans = 0
    for (i in 0 until n) {
        val res = mutableListOf<Interval>()
        var cur = Interval(0, 0, 0)
        for (j in 0 until m) {
            if (d[i][j]) {
                cur.s++
                cur.end++
            } else {
                if (cur.s > 0 || res.isEmpty()) res += cur
                cur = Interval(0, j + 1, j + 1)
            }
        }
        if (res.lastOrNull() != cur) res += cur
        val line = res.sortedByDescending { it.s }.take(2)
        lines += line
        for (j in 0 until m) {
            val col = s[j]
            val first = line[0]
            val second = col[0]
            val tmp =
                if (i in second.start until second.end && j in first.start until first.end) {
                    fun grep(i: Int, interval: Interval, j: Int, other: List<Interval>): Int {
                        val a = mutableListOf<Int>()
                        a += other[0].end - i - 1
                        a += i - other[0].start - 1
                        other.getOrNull(1)?.let {
                            a += it.s
                        }
                        return a.maxOf { it } + interval.s
                    }
                    maxOf(grep(i, line[0], j, s[j]), grep(j, s[j][0], i, line))
                } else {
                    first.s + second.s
                }
            ans = maxOf(ans, tmp)
        }
    }
    ans = maxOf(ans, lines.sortedByDescending { it[0].s }.take(2).sumOf { it[0].s })
    ans = maxOf(ans, lines.maxOf { it.sumOf { it.s } })
    ans = maxOf(ans, s.map { it[0] }.sortedByDescending { it.s }.take(2).sumOf { it.s })
    ans = maxOf(ans, s.map { it.take(2) }.maxOf { it.sumOf { it.s } })

    println(ans)
}
/*
1
7 9
##.##..##
#....#.#.
.#.#.#.#.
.###.#...
#.#..#..#
##.......
..####.#.
 */
/*
5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##
 */
val reader = System.`in`.bufferedReader()
//val tokenizer = StreamTokenizer(reader)

fun readInt() = reader.readLine().toInt()
fun read(): String = reader.readLine()
fun readInts() = reader.readLine().split(" ").map { it.toInt() }

inline fun withFastOut(n: Int = 1, fn: BufferedWriter.() -> Unit) {
    repeat(n) { fn(System.out.bufferedWriter()) }
}