def get_matrix():
    n, m = (int(i) for i in input().split())
    l = [[False for i in range(m)] for i in range(n)]
    for i in range(n):
        for j, el in enumerate(list(input())):
            l[i][j] = el == "."
    return l


def gor(mat):
    br = []
    n, m = len(mat), len(mat[0])
    for i in range(n):
        line = mat[i]
        beg = None
        le = 0
        for j, ch in enumerate(line):
            if ch:
                if beg is None:
                    beg = j
                    le = 1
                else:
                    le += 1
            else:
                if beg is not None:
                    br.append(((i, beg), (i, beg + le - 1)))
                    beg = None
        if beg is not None:
            br.append(((i, beg), (i, beg + le - 1)))
    return br


def transpose(mat):
    n, m = len(mat), len(mat[0])
    l = [[False for i in range(n)] for i in range(m)]
    for i in range(m):
        for j in range(n):
            l[i][j] = mat[j][i]
    return l


def vert(mat):
    res = gor(transpose(mat))
    res = [((i[0][1], i[0][0]), (i[1][1], i[1][0])) if i[1][1] > i[0][1] else ((i[1][1], i[0][0]), (i[0][1], i[1][0])) for i in res]
    return res

def intersectq(lineg, linev):
    x0v, y0v = linev[0]
    x1v, y1v = linev[1]
    x0g, y0g = lineg[0]
    x1g, y1g = lineg[1]
    if x0g <= x0v <= x1g and y0v <= y0g <= y1v:
        return x0v, y0g
    return None

def len_l(line):
    x0, y0 = line[0]
    x1, y1 = line[1]
    if x0 == x1:
        return abs(y1 - y0) + 1
    else:
        return abs(x1 - x0) + 1

def f():
    mat = get_matrix()
    g = gor(mat)
    v = vert(mat)
    g = sorted(g, key=len_l, reverse=True)
    v = sorted(v, key=len_l, reverse=True)

    if len(g) >= 2:
        res_g = len_l(g[0]) + len_l(g[1])
    else:
        res_g = 0

    if len(v) >= 2:
        res_v = len_l(v[0]) + len_l(v[1])
    else:
        res_v = 0

    res = 0
    if len(g) == 0 and len(v) == 0:
        print(0)
        return
    if intersectq(v[0], g[0]) is None:
        res = len_l(v[0]) + len_l(g[0])
        print(max(res, res_v, res_g))
        return
    else:
        xi, yi = intersectq(v[0], g[0])
        x0v, y0v = v[0][0]
        x1v, y1v = v[0][1]

        x0g, y0g = g[0][0]
        x1g, y1g = g[0][1]

        p0 = xi - x0v
        p1 = x1v - xi

        p3 = yi - y0g
        p4 = y1g - yi

        res = max((p0 + p1 + 1 + p3), (p0 + p1 + 1 + p4), (p3 + p4 + 1 + p0), (p3 + p4 + 1 + p1))
        print(max(res, res_v, res_g))
        return




t = int(input())
for _ in range(t):
    f()