#include <iostream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

int n;
int cnt = 0;

struct Config {
    int *a;
    Config(int n) {
        a = new int[n];
    }
};
Config *final;
vector <int> path;

bool eq(Config *a, Config *b) {
    for (int i = 0; i < n; i++)
        if (a->a[i] != b->a[i])
            return false;
    return true;
}

Config *copy(Config *a) {
    auto *ret = new Config(n);
    for (int i = 0; i < n; i++) {
        ret->a[i] = a->a[i];
    }
    return ret;
}

int getSet(set <int> *s, int ind) {
    int cnt = 0;
    for (int elem : *s) {
        if (cnt == ind)
            return elem;
        cnt++;
    }
}

int calc(Config *conf, int depth, int prev) {
    Config *next = copy(conf);
    set <int> unused_indexes;
    for (int i = 0; i < n - 1; i++)
        if (i != prev)
            unused_indexes.insert(i);
    while (!unused_indexes.empty()) {
        int set_i = rand() % unused_indexes.size();
        int ri = getSet(&unused_indexes, set_i);
        int razn = abs(next->a[ri] - next->a[ri + 1]);
        if (razn <= 1) {
            unused_indexes.erase(ri);
            continue;
        }

        swap(next->a[ri], next->a[ri + 1]);
        path.push_back(ri);
        cnt++;
        if (cnt > 20000) return -1;

        if (eq(next, final)) return depth;

        int result = calc(next, depth + 1, ri);
        if (result != -1)
            return result;
        swap(next->a[ri], next->a[ri + 1]);
        path.pop_back();
    }
    return -1;
}

int main() {
    cin >> n;
    auto* init = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> init->a[i];

    final = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> final->a[i];

    int result = calc(init, 1, -1);
    cout << result << endl;
    for (int i = 0; i < path.size(); i++) {
        cout << path[i] + 1 << " ";
    }
}
