#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = 998244353, N = 207;

int dp[N][N];

int mul(int a, int b) {
    return a * b % mod;
}

int fp(int a, int p) {
    int ans = 1, c = a;
    for (int i = 0; (1ll << i) <= p; ++i) {
        if ((p >> i) & 1) {
            ans = mul(ans, c);
        }
        c = mul(c, c);
    }
    return ans;
}

int inv(int a) {
    return fp(a, mod - 2);
}

void add(int &a, int b) {
    a += b;
    while (a >= mod) {
        a -= mod;
    }
}

int iv[N];
int C(int n, int k) {
    int ans = 1;
    for (int i = 0; i < k; ++i) {
        ans = mul(ans, n - i);
        ans = mul(ans, iv[i + 1]);
    }
    return ans;
}
int comb[N][N];
#define app push_back
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    iv[0] = 1;
    for (int i = 1; i < N; ++i) {
        iv[i] = inv(i);
    }
    int n, k, s;
    cin >> n >> k >> s;

    for (int i = 0; i < N; ++i) {
        for (int j =0; j <= i; ++j) {
            comb[i][j] = C(i, j);
        }
    }
    int pos = -1;
    vector <int> q(k);
    for (int i = 0; i < k; ++i) {
        cin >> q[i];
        if (q[i] == s) {
            pos = i;
        }
    }

    auto arc = [&] (int l, int r) {
        if (l < r) {
            return r - l;
        }
        else {
            return n - l + r;
        }
    };

    vector <int> ln;
    for (int sh = 0; sh < k; ++sh) {
        int r = (pos - sh+k)%k;
        int l = (r + k - 1) % k;
        ln.app(arc(q[l], q[r]));
    }

    /*
        cout << ln[0] << ' ' << ln[1] << endl;*/
    dp[0][0] = 1;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= k; ++j) {
            for (int t = 0; j + t < i + 1; ++t) {
                add(dp[i + 1][j + t], mul(mul(dp[i][j], comb[j + t][t]),fp(ln[i],t)));
            }
        }
    }
    /*
    for (int i = 0; i <= k; ++i) {
        for (int j = 0; j <= i; ++j) {
            cout << dp[i][j] << ' ';
        }
        cout << endl;
    }
*/
    int ans = 0;
    for (int tot= 0; tot < k; ++tot) {
        add(ans,mul(dp[k][tot],inv(fp(n,tot))));
        //add(ans,mul(dp[k][tot],inv(C_(n,tot))));

    }
    //cout << dp[2][1] << endl;
    cout << ans << endl;

    return 0;
}
