#include <bits/stdc++.h>

using namespace std;
#define int long long

void ckmin(int &a, int b) {
    if (b < a) {
        a = b;
    }
}
const int N = 2e5+7;
int cnt[N], mn[N << 2], prop[N << 2], sum[N << 2], pref[N];

void relax_min(int v) {
    sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
}
void gap(int v, int l, int r, int x) {
    int len = r - l + 1;
    prop[v] = x;
    sum[v] = x * len;
}
void push(int v, int l, int r, int m) {
    if (prop[v] != -1) {
        gap(v * 2 + 1, l, m, prop[v]);
        gap(v * 2 + 2, m + 1, r, prop[v]);
        prop[v] = -1;
    }
}
void setval(int v, int l, int r, int ql, int qr, int x) {
    if (r < ql || qr < l) {
        return;
    }
    if (ql <= l && r <= qr) {
        gap(v, l, r, x);
        return;
    }
    int m = (l + r) / 2;
    push(v, l, r, m);
    setval(v * 2 + 1, l, m, ql, qr, x);
    setval(v * 2 + 2, m + 1, r, ql, qr, x);
    relax_min(v);
}
void build_min(int v, int l, int r) {
    if (l == r) {
        sum[v] = pref[l];
        return;
    }
    int m = (l + r) / 2;
    build_min(v * 2 + 1, l, m);
    build_min(v * 2 + 2, m + 1, r);
    relax_min(v);
}

void relax_cnt(int v) {
    mn[v] = min(mn[v * 2 + 1], mn[v * 2 + 2]);
}
void build_cnt(int v, int l, int r) {
    if (l == r) {
        mn[v] = cnt[l];
        return;
    }
    int m = (l + r) / 2;
    build_cnt(v * 2 + 1, l, m);
    build_cnt(v * 2 + 2, m + 1, r);
    relax_cnt(v);
}
void setcnt(int v, int l, int r, int i, int x) {
    if (l == r) {
        mn[v] = x;return;
    }
    int m = (l + r) / 2;
    if (i <= m) {
        setcnt(v * 2 + 1, l, m, i, x);
    }
    else {
        setcnt(v * 2 + 2, m + 1, r, i, x);
    }
    relax_cnt(v);
}
int getmin_cnt(int v, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) {
        return 1e9;
    }
    if (ql <= l && r <= qr) {
        return mn[v];
    }
    int m = (l + r) / 2;
    return min(getmin_cnt(v * 2 + 1, l, m, ql, qr), getmin_cnt(v * 2 + 2, m + 1, r, ql, qr));
}
int leftless(int v, int l, int r, int from, int x) {
    if (mn[v] >= x || r < from) {
        return N;
    }
    if (l == r) {
        return l;
    }
    int m = (l + r) / 2;
    int t = leftless(v * 2 + 1, l,m, from, x);
    if (t != N) {
        return t;
    }
    else {
        return leftless(v * 2 + 2, m + 1, r, from, x);
    }
}



int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    for (int i = 0; i < (N << 2); ++i) {
        prop[i] = -1;
    }

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> cnt[i];
    }
    for (int i = 0; i < N; ++i) {
        pref[i] = cnt[i];
    }
    for (int i= 1; i < N; ++i) {
        ckmin(pref[i], pref[i - 1]);
    }
    build_cnt(0, 0, N - 1);
    build_min(0, 0, N - 1);
    cout << sum[0] << endl;
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        if (p == 1) {
            cnt[v]++;
        }
        else {
            cnt[v]--;
        }
        setcnt(0, 0, N - 1, v, cnt[v]);
        int lmn = getmin_cnt(0, 0, N - 1, 0, v);
        int to = leftless(0, 0, N - 1, v, lmn);
        setval(0, 0, N - 1, v, to - 1, lmn);
        cout << sum[0] << endl;
    }
    return 0;
}
