#include<bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;
#define x first
#define y second
#define pb push_back
#define mp make_pair

int n, g;
set < pair < int, int > > was;

int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a % b;
        a = b, b = c;
    }
    return a + b;
}

void dfs(int x, int y) {
    if (was.find({x, y}) != was.end() || max(x, y) > n) return;
    was.insert({x, y});
    int mult = max(x * y, g);
    while (mult < min(x * y + x, n + 1)) {
        if (gcd(mult, x) == g) {
            dfs(mult, x);
        }
        mult += g;
    }
}

int G(int x, int y) {
    if (x == 1 && y == 1) return -1;
    if (y == 0) return x;
    return G(y, x / y);
}

vector < pair < int, int > > go[200005];

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ofstream out("allpairs.txt");
    int q;
    int p;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j < i; j++) {
            int g = __gcd(i, j);
            if (G(i, j) == g) {
                go[g].push_back({i, j});
            }
        }
        cerr << i << endl;
    }
    int sum = 0;
    for (int g = 2; g <= n; g++) {
        if (go[g].empty()) continue;

        cout << g << " " << go[g].size() << endl;
        sum += go[g].size();

        out << g << '\n';
        for (auto tt : go[g]) out << tt.x << ' ' << tt.y << '\n';
    }
    cout << "! " << sum << endl;
    return 0;
}
