#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
const int _1e9 = 1'000'000'000;
int addH(vector<string>&v) {
	int maxl = 0;
	int frI = 0;
	int frJ = 0;
	for (int i = 0; i < v.size(); ++i) {
		int curl = 0;
		for (int q = 0; q < v[i].size(); ++q) {
			if (v[i][q] == '.') {
				curl++;
			} else {
				if (curl > maxl) {
					maxl = curl;
					frI = i;
					frJ = q - curl;
				}
				curl = 0;
			}
		}
		if (curl > maxl) {
			maxl = curl;
			frI = i;
			frJ = v[i].size() - curl;
		}
	}
	for (int q = frJ; q < frJ + maxl; ++q) {
		v[frI][q] = '#';
	}
	return maxl;
}

int addV(vector<string>& v) {
	int maxl = 0;
	int frI = 0;
	int frJ = 0;
	for (int q = 0; q < v[0].size(); ++q) {
		int curl = 0;
		for (int i = 0; i < v.size(); ++i) {
			if (v[i][q] == '.') {
				curl++;
			}
			else {
				if (curl > maxl) {
					maxl = curl;
					frI = i - curl;
					frJ = q;
				}
				curl = 0;
			}
		}
		if (curl > maxl) {
			maxl = curl;
			frI = v.size() - curl;
			frJ = q;
		}
	}
	for (int i = frI; i < frI + maxl; ++i) {
		v[i][frJ] = '#';
	}
	return maxl;
}
void main2() {
	int n, m;
	cin >> n >> m;
	vector<string>v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	vector<string>vH = v;
	int ansH = addH(vH);
	vector<string>vV = v;
	int ansV = addV(vV);
	cout << max(ansH + max(addH(vH), addV(vH)), ansV + max(addH(vV), addV(vV))) << '\n';
}
int32_t main() {
	ios_base::sync_with_stdio(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		main2();
	}
	return 0;
}