#include <iostream>
#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define len(a) (int)(a.size())

using namespace std;

int get_ans(vector<vector<char> >& a) {
    int ans = 0;
    int n = len(a);
    int m = len(a[0]);
    vector<int> up(n, 0), down(n, 0);
    vector<int> right(m, 0), left(m, 0);
    int ma1 = 0, ma2 = 0;
    forn(i, n) {
        int prev = -1;
        vector<pair<int, int> > e;
        forn(j, m) {
            if (a[i][j] == '#') {
                if (prev != j - 1) {
                    e.emplace_back(prev + 1, j - 1);
                }
                prev = j;
            }
        }
        if (prev != m - 1) {
            e.emplace_back(prev + 1, m - 1);
        }
        for (auto [l, r]: e) {
            up[i] = max(up[i], r - l + 1);
            down[i] = max(down[i], r - l + 1);
            left[r] = max(left[r], r - l + 1);
            right[l] = max(right[l], r - l + 1);
            if (r - l + 1 > ma1) {
                ma2 = ma1; ma1 = r - l + 1;
            } else if (r - l + 1 > ma2) {
                ma2 = r - l + 1;
            }
            for (int mid = l; mid <= r; ++mid) {
                left[mid] = max(left[mid], mid - l + 1);
                right[mid] = max(right[mid], r - mid + 1);
            }
        }
    }
    ans = max(ans, ma1 + ma2);
    for (int i = 1; i < n; ++i) {
        up[i] = max(up[i - 1], up[i]);
    }
    for (int i = n - 2; i >= 0; i--) {
        down[i] = max(down[i + 1], down[i]);
    }
    for (int i = 1; i < m; ++i) {
        left[i] = max(left[i - 1], left[i]);
    }
    for (int i = m - 2; i >= 0; i--) {
        right[i] = max(right[i + 1], right[i]);
    }
    for (int j = 0; j < m; j++) {
        int prev = -1;
        vector<pair<int, int> > e;
        forn(i, n) {
            if (a[i][j] == '#') {
                if (prev != i - 1) {
                    e.emplace_back(prev + 1, i - 1);
                }
                prev = i;
            }
        }
        if (prev != n - 1) {
            e.emplace_back(prev + 1, n - 1);
        }
        for (auto[l, r]: e) {
//            cout << j << ' ' << l << ' ' << r << endl;
            int res = 0;
            if (l > 0) {
                res = max(res, up[l - 1]);
//                cout << "up " <<  up[l - 1] << endl;
            }
            if (r < n - 1) {
                res = max(res, down[r + 1]);
//                cout << "down " <<  down[r + 1] << endl;
            }
            if (j > 0) {
                res = max(res, left[j - 1]);
//                cout << "left " <<  left[j - 1] << endl;
            }
            if (j < m - 1) {
                res = max(res, right[j + 1]);
//                cout << "right " <<  right[j + 1] << endl;
            }
            ans = max(ans, r - l + 1 + res);
        }
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char> > a(n, vector<char> (m));
    vector<vector<char> > b(m, vector<char> (n));
    forn(i, n) {
        forn(j, m) {
            cin >> a[i][j];
            b[j][i] = a[i][j];
        }
    }
//    cout << get_ans(a) << ' ' << get_ans(b) << endl;
    cout << max(get_ans(a), get_ans(b)) << '\n';
//cout << "-------------" << endl;
//    cout << "A" << endl;
//    get_ans(a);
//    cout << "B" << endl;
//    get_ans(b);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
