#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 998244353;
const int INF = LLONG_MAX;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

		int n, m; cin >> n;
		m = n;
		vector<string> r(n);
		for(auto &i : r)
			cin >> i;
		int ans = 1;
		vector<int> minrow(n, INF), mincol(m, INF);
		vector<int> maxrow(n, -1), maxcol(m, -1);
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++) {
				if(r[i][j] == '#') {
					minrow[i] = min(minrow[i], j);
					maxrow[i] = max(maxrow[i], j);
					mincol[j] = min(mincol[j], i);
					maxcol[j] = max(maxcol[j], i);
				}
			}
		}
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++) {
				if(r[i][j] == '?') {
					if(minrow[i] < j && maxrow[i] > j)
						ans = 0;
					else if(mincol[j] < i && maxcol[j] > i)
						ans = 0;
					else {
						int cnt = 0;
						if(minrow[i] < j) ++cnt;
						if(maxrow[i] > j) ++cnt;
						if(mincol[j] < i) ++cnt;
						if(maxcol[j] > i) ++cnt;
						if(cnt == 1)
							ans = (ans << 1) % mod;
						else if (cnt == 0) ans = (ans << 2) % mod;
					}
				}
			}
		}
		cout << ans << "\n";
	return 0;
}