#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 998244353;
const int INF = LLONG_MAX;
const int MAXN = 1010;

int l[MAXN][MAXN], r[MAXN][MAXN];
int u[MAXN][MAXN], d[MAXN][MAXN];

		bool checkleft(int i, int j) {
			return (l[i][j] < j);
		};
		bool checkright(int i, int j) {
			return (r[i][j] > j);
		};
		bool checkup(int i, int j) {
			return (u[i][j] < i);
		};
		bool checkdown(int i, int j) {
			return (d[i][j] > i);
		};

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

		int n; cin >> n;
		vector<string> s(n);
		for(auto &i : s)
			cin >> i;
		int ans = 1;
		
		for(int i = 0; i < n; i++) {
			int left = INF;
			for(int j = 0; j < n; j++) {
				if(s[i][j] == '#')
					left = j;
				else if(s[i][j] == '.')
					left = INF;
				l[i][j] = left;
			}
			int right = -1;
			for(int j = n - 1; j >= 0; j--) {
				if(s[i][j] == '#')
					right = j;
				else if(s[i][j] == '.')
					right = -1;
				r[i][j] = right;
			}
		}
		for(int j = 0; j < n; j++) {
			int up = INF;
			for(int i = 0; i < n; i++) {
				if(s[i][j] == '#')
					up = i;
				else if(s[i][j] == '.')
					up = INF;
				u[i][j] = up;
			}
			int down = -1;
			for(int i = n - 1; i >= 0; i--) {
				if(s[i][j] == '#')
					down = i;
				else if(s[i][j] == '.')
					down = -1;
				d[i][j] = down;
			}
		}

		for(int i = 0; i < n; i++) {
			for(int j = 0; j < n; j++) {
				if(s[i][j] == '?') {
					if(checkleft(i, j) && checkright(i, j))
						ans = 0;
					else if(checkup(i, j) && checkdown(i, j))
						ans = 0;
					else {
						int cnt = 0;
						if(checkleft(i, j)) ++cnt;
						if(checkright(i, j)) ++cnt;
						if(checkup(i, j)) ++cnt;
						if(checkdown(i, j)) ++cnt;
						if(cnt == 1)
							ans = (ans << 1) % mod;
						else if (cnt == 0) 
							ans = (ans << 2) % mod;
					}
				}
			}
		}
		cout << ans << "\n";
	return 0;
}