#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int solve_hor(int n, int m, vector<vector<char>> v) {
    int mx = 0, mx_i = -1, mx_j = -1;
    for (int i = 0; i < n; i++) {
        int l = 0;
        for (int j = 0; j < m; j++) {
            if (v[i][j] == '.') {
                l++;
                if (l > mx) {
                    mx = l;
                    mx_i = i;
                    mx_j = j;
                }
            } else {
                if (l > mx) {
                    mx = l;
                    mx_i = i;
                    mx_j = j;
                }
                l = 0;
            }
        }
    }
    for (int j = mx_j - mx + 1; j <= mx_j; j++) {
        v[mx_i][j] = '#';
    }
    int ans = 0;
    {
        int mx = 0;
        for (int i = 0; i < n; i++) {
            int l = 0;
            for (int j = 0; j < m; j++) {
                if (v[i][j] == '.') {
                    l++;
                    mx = max(mx, l);
                } else {
                    mx = max(mx, l);
                    l = 0;
                }
            }
        }
        ans = max(ans, mx);
    }
    {
        int mx = 0;
        for (int j = 0; j < m; j++) {
            int l = 0;
            for (int i = 0; i < n; i++) {
                if (v[i][j] == '.') {
                    l++;
                    mx = max(mx, l);
                } else {
                    mx = max(mx, l);
                    l = 0;
                }
            }
        }
        ans = max(ans, mx);
    }
    ans += mx;
    return ans;
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<char>> v(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }
    int ans = solve_hor(n, m, v);
    vector<vector<char>> tmp(m, vector<char>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            tmp[j][i] = v[i][j];
        }
    }
    ans = max(ans, solve_hor(m, n, tmp));
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int t; cin >> t; while(t--)
    solve();
    return 0;
}
