#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        bool a[n][m];

        vector<int> mx_top(n, 0), mx_bot(n, 0), mx_row(n, 0);
        vector<int> mx_left(m, 0), mx_right(m, 0);
        for (int i=0; i < n; i++) {
            int cur = 0;
            mx_row[i] = 0;
            for (int j=0; j < m; j++) {
                char x;
                cin >> x;
                if (x == '.') a[i][j] = false;
                else a[i][j] = true;
                if (a[i][j]) cur = 0;
                else cur++;
                mx_row[i] = max(mx_row[i], cur);
                mx_left[j] = max(mx_left[j], mx_row[i]);
            }
            cur = 0;
            mx_row[i] = 0;
            for (int j=m-1; j > -1; j--) {
                if (a[i][j]) cur = 0;
                else cur++;
                mx_row[i] = max(mx_row[i], cur);
                mx_right[j] = max(mx_right[j], mx_row[i]);
            }
        }
        mx_bot[n-1] = mx_row[n-1];
        for (int i=n-2; i>-1; i--) {
            mx_bot[i] = max(mx_bot[i+1], mx_row[i]);
        }
        mx_top[0] = mx_row[0];
        for (int i=1; i<n; i++) {
            mx_top[i] = max(mx_top[i-1], mx_row[i]);
        }
        //*************
        int ans = 0;
        for (int j=0; j < m; j++) {
            int end = 0;
            for (int i=-1; i<n; i++) {
                if (i < 0 || a[i][j]){
                    end = i+1;
                    while (end < n && !a[end][j]) {
                        int mx = 0;
                        if (j) mx = max(mx_left[j-1], mx);
                        if (j < m   -1) mx = max(mx_right[j+1], mx);
                        if (i >= 0) mx = max(mx_top[i], mx);
                        if (end < n-1) mx = max(mx_bot[end+1], mx);
                        ans = max(ans, mx + (end - i));
                        end++;
                    }
                }
            }
        }
        for (int j=0; j < m; j++) {
            int beg = 0;
            for (int i = n; i > -1; i--) {
                if (i == n || a[i][j]){
                    beg = i-1;
                    while (beg >= 0 && !a[beg][j]) {
                        int mx = 0;
                        if (j) mx = max(mx_left[j-1], mx);
                        if (j < m-1) mx = max(mx_right[j+1], mx);
                        if (beg) mx = max(mx_top[beg-1], mx);
                        if (i < n) mx = max(mx_bot[i], mx);
                        ans = max(ans, mx + (i - beg));
                        beg--;
                    }
                }
            }
        }
        //*********
        vector<int> c_mx_left(m, 0), c_mx_right(m, 0), mx_col(m, 0);
        vector<int> c_mx_top(n, 0), c_mx_bot(n, 0);
        for (int j=0; j < m; j++) {
            int cur = 0;
            mx_col[j] = 0;
            for (int i=0; i<n; i++) {
                if (a[i][j]) cur = 0;
                else cur++;
                mx_col[j] = max(mx_col[j], cur);
                c_mx_top[i] = max(c_mx_top[i], mx_col[i]);
            }
            cur = 0;
            mx_col[j] = 0;
            for (int i=n-1; i > -1; i--) {
                if (a[i][j]) cur = 0;
                else cur++;
                mx_col[j] = max(mx_col[j], cur);
                c_mx_bot[i] = max(c_mx_bot[i], mx_col[i]);
            }
        }
        c_mx_right[m-1] = mx_col[m-1];
        for (int j=m-2; j>-1; j--) {
            c_mx_right[j] = max(c_mx_right[j+1], mx_col[j]);
        }
        c_mx_left[0] = mx_col[0];
        for (int j=1; j < m; j++) {
            c_mx_left[j] = max(c_mx_left[j-1], mx_col[j]);
        }
        for (int i=0; i < n-1; i++) ans = max(ans, mx_top[i] + mx_bot[i+1]);
        for (int j=0; j < m-1; j++) ans = max(ans, c_mx_left[j] + c_mx_right[j+1]);
        for (int i=0; i < n-1; i++) ans = max(ans, c_mx_top[i] + c_mx_bot[i+1]);
        for (int j=0; j < m-1; j++) ans = max(ans, mx_left[j] + mx_right[j+1]);
        cout << ans << endl;
    }
    return 0;
}
