#include<bits/stdc++.h>
using namespace std;
 
// #define LOCAL
#define MULTITEST
 
#define int long long
 
#ifdef LOCAL 
    #define debug(x) cerr << #x << " = " << x << endl;
    #define ddebug(x, y) cerr << #x << " = " << x << " , " << #y << " = " << y << endl;
#else
    #define debug(x);
    #define ddebug(x, y);
#endif
 
template<typename T>
istream& operator >> (istream &in, vector<T> &v){
    for(int i = 0; i < v.size(); i++)
        in >> v[i];
 
    return in;
}
 
template<typename T>
ostream& operator << (ostream &out, vector<T> &v){
    for(int i = 0; i < v.size(); i++)
        out << v[i] << " \n"[i + 1 == v.size()];
 
    return out;
}
 
template<typename T, typename U>
ostream& operator << (ostream &out, vector<pair<T, U>> &v){
    for(int i = 0; i < v.size(); i++)
        out << v[i].first << ' ' << v[i].second << '\n';
 
    return out;
}
 
template<typename T, typename U>
istream& operator >> (istream &in, pair<T, U> &p){
    in >> p.first >> p.second;
    return in;
}
 
template<typename T, typename U>
ostream& operator << (ostream &out, pair<T, U> &p){
    out << p.first << ' ' << p.second;
    return out;
}
 
#define ll long long
#define ld long double
 
#define pii pair<int, int>
#define fi first
#define se second
 
#define vi vector<int> 
#define vvi vector<vi>
#define pb push_back
 
#define vpii vector<pii>
#define vvpii vector<vpii>
 
#define ALL(x) x.begin(), x.end()
 
const int INF32 = 2e9 + 5;
const ll INF64 = 4e9 + 5;   
 
const int mod = 1e9 + 7;
const ld eps = 1e-10;
 
const int sz = 20;
const int SZ = 1 << 20;
 
int _solve(vvi a){
    int n = a.size() - 2;
    int m = a[0].size() - 2;
 
    vvi next(n + 2, vi(m + 2));
    vvi last(n + 2, vi(m + 2));
 
    vi mx_r(n + 2);
    vi lmx_r(n + 2);

    for (int i = 1; i <= n; i++){
        last[i][0] = 0;
        for (int j = 1; j <= m; j++){
            last[i][j] = last[i][j - 1];
            if (a[i][j] == 1){
                last[i][j] = j;
            }
        }
 
        next[i][m + 1] = m + 1;
        for (int j = m; j; j--){
            next[i][j] = next[i][j + 1];
            if (a[i][j] == 1){
                next[i][j] = j;
            }
        }

        for (int j = 1; j <= m; j++){
        	if (a[i][j + 1] && !a[i][j]){
        		int cur = j - last[i][j];
        		lmx_r[i] = max(lmx_r[i], cur);
        		if (lmx_r[i] > mx_r[i]){
        			swap(lmx_r[i], mx_r[i]);
        		}
        	}
        }
    }
 
    vi pref(n + 2);
    for (int i = 1; i <= n + 1; i++){
    	pref[i] = max(pref[i - 1], mx_r[i]);
    }

    vi suff(n + 3);
    for (int i = n; i >= 0; i--){
    	suff[i] = max(suff[i + 1], mx_r[i]);
    }

    // cout << pref << endl;
    // cout << suff << endl;
 
    int ans = 0;
 
    int MX = 0;
    int lMX = 0;
 
    for (int st = 1; st <= m; st++){
        int cur = 0;
        int mx = 0;
        int _mx = 0;
        for (int r = 1; r <= n + 1; r++){
            mx = max(mx, st - last[r][st]);
            mx = max(mx, next[r][st] - st);
            
            int kek = next[r][st] - 1 - last[r][st];
            _mx = max(_mx, kek == mx_r[r] ? lmx_r[r] : mx_r[r]);

            if (a[r][st]){
                lMX = max(lMX, cur);
                if (lMX > MX){
                    swap(lMX, MX);
                }
                cur = 0;
                mx = 0;
                _mx = 0;
            }else{
                cur++;
            }
            // ddebug(cur, mx)
            ans = max(ans, mx + cur - 1);
            // cerr << r << ' ' << cur << ' ' << _mxendl;
            ans = max(ans, cur + max({_mx, pref[r - cur], suff[r + 1]}));
        }
        // cerr << endl;
    }
    // ddebug(lMX, MX)
    ans = max(ans, lMX + MX);
 
    return ans;
}
 
void Solve(){
 
    int n, m;
    cin >> n >> m;
    vvi a(n + 2, vi(m + 2, 1));
    vvi b(m + 2, vi(n + 2, 1));
     
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            char c;
            cin >> c;
            if (c == '.'){
                a[i][j] = 0;
                b[j][i] = 0;
            }else{
                a[i][j] = 1;
                b[j][i] = 1;
            }
        }
    }
 
    // cout << a;
 
// cout <<   _solve(a);
//     return;
 
    cout << max(_solve(a), _solve(b));
 
}
 
signed main(){
 
    srand(time(NULL));
    cout << fixed << setprecision(10);
 
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(NULL);
        cin.tie(NULL);
        cout.tie(NULL);
    #endif
 
    int test_cnt = 1;
    #ifdef MULTITEST
        cin >> test_cnt;
    #endif
     
    for(int i = 1; i <= test_cnt; i++){
        Solve();
        cout << '\n';
    }
}