#include <bits/stdc++.h>

using namespace std;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> suf_col_max(m, vector<int>(n, 0)), pref_col_max(m, vector<int>(n, 0)),
                        suf_row_max(n, vector<int>(m, 0)), pref_row_max(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        int cur_max = 0;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#') {
                cur_max = 0;
            } else {
                ++cur_max;
            }
            pref_row_max[i][j] = max(cur_max, j > 0 ? pref_row_max[i][j - 1] : 0);
        }
        cur_max = 0;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] == '#') {
                cur_max = 0;
            } else {
                cur_max += 1;
            }
            suf_row_max[i][j] = max(cur_max, j + 1 >= m ? 0:  suf_row_max[i][j + 1]);
        }
    }
    for (int i = 0; i < m; ++i) {
        int cur_max = 0;
        for (int j = 0; j < n; ++j) {
            if (a[j][i] == '#') {
                cur_max = 0;
            } else {
                ++cur_max;
            }
            pref_col_max[i][j] = max(cur_max, j > 0 ? pref_col_max[i][j - 1] : 0);
        }
        cur_max = 0;
        for (int j = n - 1; j >= 0; --j) {
            if (a[j][i] == '#') {
                cur_max = 0;
            } else {
                cur_max += 1;
            }
            suf_col_max[i][j] = max(cur_max, j + 1 >= n ? 0:  suf_col_max[i][j + 1]);
        }
    }

    int ans = 0;
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; ++i) {
        if (pref_row_max[i][m - 1] >= mx1) {
            mx2 = mx1;
            mx1 = pref_row_max[i][m - 1];
        } else if (pref_row_max[i][m - 1] > mx2) {
            mx2 = pref_row_max[i][m - 1];
        }
    }
    ans = mx1 + mx2;
    mx1 = 0, mx2 = 0;
    for (int i = 0; i < m; ++i) {
        if (pref_col_max[i][n - 1] >= mx1) {
            mx2 = mx1;
            mx1 = pref_col_max[i][n - 1];
        } else if (pref_col_max[i][n - 1] > mx2) {
            mx2 = pref_col_max[i][n - 1];
        }
    }
    ans = max(ans, mx1 + mx2);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            {
                int len1 = pref_row_max[i][m - 1];
                int len2 = max(i > 0 ? pref_col_max[j][i - 1] : 0, i + 1 < n ? suf_col_max[j][i + 1] : 0);
                ans = max(ans, len1 + len2);
            }

            {
                int len1 = pref_col_max[j][n - 1];
                int len2 = max(j > 0 ? pref_row_max[i][j - 1] : 0, j + 1 < m ? suf_row_max[i][j + 1] : 0);
                ans = max(ans, len1 + len2);
            }
        }
    }

    cout << ans << '\n';

}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
