#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define ll int64_t
#define pii pair < int, int >
#define pb push_back
#define int ll
#define f first
#define s second
#define ld long double

using namespace std;
using namespace __gnu_pbds;

//template < typename > T;
//typedef tree < T, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;


int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        int p[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char t;
                cin >> t;
                p[i][j] = 1;
                if (t == '#') {
                    p[i][j] = 0;
                }
            }
        }

        pair < pii, pii > w[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                w[i][j].f.f = 1;
                w[i][j].f.s = 1;
                if (i) w[i][j].f.f += w[i - 1][j].f.f;
                if (j) w[i][j].f.s += w[i][j - 1].f.s;
                if (p[i][j] == 0) w[i][j].f.s = 0, w[i][j].f.f = 0;
            }
        }

        for (int i = n - 1; i >= 0; i--) {
            for (int j = m - 1; j >= 0; j--) {
                w[i][j].s.f = 1;
                w[i][j].s.s = 1;
                if (i + 1 < n) w[i][j].s.f += w[i + 1][j].s.f;
                if (j + 1 < m) w[i][j].s.s += w[i][j + 1].s.s;
                if (p[i][j] == 0) w[i][j].s.f = 0, w[i][j].s.s = 0;
            }
        }


        int a[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = 0;
                if (i) a[i][j] = a[i - 1][j];
                if (j) a[i][j] = max(a[i][j], a[i][j - 1]);
                if (i && j) a[i][j] = max(a[i][j], a[i - 1][j - 1]);
                a[i][j] = max(a[i][j], w[i][j].f.f);
                a[i][j] = max(a[i][j], w[i][j].f.s);
            }
        }

        int b[n][m];
        for (int i = n - 1; i >= 0; i--) {
            for (int j = m - 1; j >= 0; j--) {
                b[i][j] = 0;
                if (i + 1 < n) b[i][j] = b[i + 1][j];
                if (j + 1 < m) b[i][j] = max(b[i][j], b[i][j + 1]);
                if (i + 1 < n && j + 1 < m) b[i][j] = max(b[i][j], b[i + 1][j + 1]);
                b[i][j] = max(b[i][j], w[i][j].s.f);
                b[i][j] = max(b[i][j], w[i][j].s.s);
            }
        }


        int res = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (p[i][j] == 0) continue;
                int len = w[i][j].f.f;
                int i1 = i - len + 1;
                int i2 = i;
                int ans = 0;
                if (j) ans = max(ans, a[n - 1][j - 1]);
                if (j + 1 < m) ans = max(ans, b[0][j + 1]);
                if (i1) ans = max(ans, a[i1 - 1][m - 1]);
                if (i2 + 1 < n) ans = max(ans, b[i2 + 1][0]);
                res = max(res, ans + len);



                len = w[i][j].f.s;
                int j1 = j - len + 1;
                int j2 = j;
                ans = 0;
                if (j1) ans = max(ans, a[n - 1][j1 - 1]);
                if (i) ans = max(ans, a[i - 1][m - 1]);
                if (i + 1 < n) ans = max(ans, b[i + 1][0]);
                if (j2 + 1 < m) ans = max(ans, b[0][j2 + 1]);

                res = max(res, ans + len);


                len = w[i][j].s.f;
                i1 = i;
                i2 = i + len - 1;
                ans = 0;
                if (j) ans = max(ans, a[n - 1][j - 1]);
                if (j + 1 < m) ans = max(ans, b[0][j + 1]);
                if (i1) ans = max(ans, a[i1 - 1][m - 1]);
                if (i2 + 1 < n) ans = max(ans, b[i2 + 1][0]);
                res = max(res, ans + len);




                len = w[i][j].s.s;
                j1 = j;
                j2 = j + len - 1;
                ans = 0;
                if (j1) ans = max(ans, a[n - 1][j1 - 1]);
                if (i) ans = max(ans, a[i - 1][m - 1]);
                if (i + 1 < n) ans = max(ans, b[i + 1][0]);
                if (j2 + 1 < m) ans = max(ans, b[0][j2 + 1]);



                res = max(res, ans + len);
            }
        }


        cout << res << "\n";
    }


    return 0;
}

