#include <bits/stdc++.h>

#define S second
#define F first
#define sz(x) ll(x.size())
#define PB push_back

using namespace std;

typedef long long ll;
const ll N = 200501;
ll psh[N * 4], t[N * 4];

ll maxn = N - 10;

void push(ll v, ll tl, ll tr)
{
    if (psh[v] == 0)
        return;

    t[v] += psh[v];

    if (tl != tr)
    {
        psh[v + v] += psh[v];

        psh[v + v + 1] += psh[v];
    }

    psh[v] = 0;
}

void upd(ll v, ll tl, ll tr, ll l, ll r, ll val)
{
    push(v, tl, tr);

    if (r < tl || tr < l || l > r)
        return;

    if (l <= tl && tr <= r)
    {
        psh[v] = val;

        push(v, tl, tr);

        return;
    }

    ll md = (tl + tr) >> 1;

    upd(v + v, tl, md, l, r, val);

    upd(v + v + 1, md + 1, tr, l, r, val);

    t[v] = min(t[v + v], t[v + v + 1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r)
{
    if (tr < l || r < tl || l > r || tl > tr)
        return 1;

    push(v, tl, tr);

    if (l <= tl && tr <= r)
    {
        if (t[v] != 0)
            return 1;

        return 0;
    }

    ll md = (tl + tr) >> 1;

    ll a = get(v + v, tl, md, l, r);

    ll b = get(v + v + 1, md + 1, tr, l, r);

    return a && b;
}

ll ans = 0;

multiset <ll> se;

ll kl[N];

ll calc(ll l)
{
    ll L = l, R = maxn;

    while (L < R)
    {
        ll md = (L + R + 1) >> 1;

        if (get(1, 0, maxn, l, md))
            L = md;
                else R = md - 1;
    }

    return L - l + 1;
}

void add(ll val)
{
    kl[val]++;

    upd(1, 0, maxn, val, val, 1);

    if (val == 0)
    {
        ll skok = calc(val);

        se.insert(skok - 1);

        ans += skok;

        upd(1, 0, maxn, val, val + skok - 1, -1);

        return;
    }

    auto it = se.lower_bound(val);

    if (it != se.begin())
    {
        it--;

        if (*it == val - 1)
        {
            se.erase(se.find(val - 1));

            ll skok = calc(val);

            ans += skok;

            upd(1, 0, maxn, val, val + skok - 1, -1);

            se.insert(val + skok - 1);
        }
    }
}

void del(ll val)
{
    kl[val]--;

    if (get(1, 0, maxn, val, val) != 0)
    {

        upd(1, 0, maxn, val, val, -1);

        return;
    }

    ll mn = *se.lower_bound(val);

    se.erase(se.find(mn));

    ans -= mn + 1;

    ans += val;

    upd(1, 0, maxn, val + 1, mn, 1);

    se.insert(val - 1);
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); istream::sync_with_stdio(0);

    ll n;

    cin >> n;

    ll skok = 1e9;

    for (ll i = 0; i < n; i++)
    {
        ll val;

        cin >> val;

        kl[i] = val;

        if (skok <= val)
        {
            upd(1, 0, maxn, i, i, val - skok);
        }
        else
        {
            if (i != 0)
            {
                for (ll t = 1; t <= skok - val; t++)
                {
                    se.insert(i - 1);
                }

                ans += i * (skok - val);
            }

            skok = val;
        }
    }

    for (ll t = 1; t <= skok; t++)
    {
        se.insert(n - 1);
    }

    ans += skok * n;

    cout << ans << endl;

    ll q;

    cin >> q;

    for (; q; q--)
    {
        ll p, val;

        cin >> p >> val;

        if (p == 1) {
            add(val);
        } else {
            del(val);
        }

        cout << ans << endl;
    }
}
