/*
 * Copyright © 6highloads (Shik, Kirsanov, Ushkov)
 * 2022
 */


#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

using namespace std;

using ll = int64_t;

int main() {
    fastio;

    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    vector<int> ops;

    for (int j = n - 1; j > 0; --j) {
        int i = 0;
        int x = b[j];
        for (int k = 0; k < n; ++k) {
            if (a[k] == x) {
                i = k;
                break;
            }
        }

        if (i < j) {
            for (int k = i; k < j; ++k) {
                if (a[k] == a[k + 1] + 1 || a[k] == a[k + 1] - 1) {
                    cout << -1;
                    return 0;
                }

                swap(a[k], a[k + 1]);
                ops.push_back(k);
            }
        }

        if (i > j) {
            for (int k = i - 1; k >= j; ++k) {
                if (a[k] == a[k + 1] + 1 || a[k] == a[k + 1] - 1) {
                    cout << -1;
                    return 0;
                }

                swap(a[k], a[k + 1]);
                ops.push_back(k);
            }
        }

    }

    cout << ops.size() << "\n";
    for (int o : ops) {
        cout << o + 1 << ' ';
    }

    return 0;
}
