import java.io.BufferedReader
import java.io.BufferedWriter
import java.io.StreamTokenizer

fun main() = withFastOut() {
    val (n, k) = readInts(2)
    val a = readInts(n).sorted()
    val d = Array(k) { mutableListOf<Int>() }
    var cur = 0
    a.forEach {
        d[cur++] += it
        cur %= k
    }
    println(d.sumOf {
        it.runningFold(0) { s, x -> s + x }.sum()
    })
}

val reader = System.`in`.bufferedReader()
val tokenizer = StreamTokenizer(reader)

fun readInt() = tokenizer.nextToken().let { tokenizer.nval.toInt() }
fun readLong() = tokenizer.nextToken().let { tokenizer.nval.toLong() }
fun read(): String = tokenizer.nextToken().let { tokenizer.sval }
fun readInts(n: Int) = List(n) { readInt() }
fun readLongs(n: Int) = List(n) { readLong() }

inline fun withFastOut(n: Int = 1, fn: BufferedWriter.() -> Unit) {
    fn(System.out.bufferedWriter())
}