#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool task(long x, long y, long a, long b)
{
	while (y > 0)
	{
		x /= y;
		if (a != 0 && b != 0) {
			a %= b;
		}
		return task(y, x, b, a);
	}
	if (x == b or x == a) {
		return 1;
	}
	else {
		return 0;
	}
}

int main()
{
	long n, q;
	vector<pair<long, long>> pi;
	cin >> n >> q;
	for (int i = 2; i <= n; ++i)
	{
		for (int j = 2; j <= i; ++j)
		{
			if (i == j || j * j == i)
			{
				pi.push_back(make_pair(i, j));
				continue;
			}
			if (task(i,j,i,j))
			{
				pi.push_back(make_pair(i, j));
			}
		}
	}

	for (int i = 0; i < q; ++i)
	{
		cin >> n;
		if (pi.size() >= n)
			cout << pi[n - 1].first << " " << pi[n - 1].second << endl;
		else cout << -1 << " " << -1 << endl;
	}
}